(defvar symbol-menu-symbols "/usr/local/share/emacs/site-lisp/symbol-menu/symbols")

(defvar symbol-menu-map nil)

(defvar symbol-menu-target-buffer nil)

(defun symbol-menu ()
  (interactive)
  (setq symbol-menu-target-buffer (current-buffer))
  (find-file-read-only-other-window symbol-menu-symbols)
  (symbol-menu-mode))

(defun symbol-menu-make-keymap ()
  (if symbol-menu-map
      nil
    (setq symbol-menu-map (make-keymap))
    (define-key symbol-menu-map "q" 'symbol-menu-quit)
    (define-key symbol-menu-map "\C-m" 'symbol-menu-insert-symbol-to-target)))
    
(defun symbol-menu-mode ()
  (symbol-menu-make-keymap)
  (use-local-map symbol-menu-map)
  (setq major-mode 'symbol-menu-mode)
  (setq mode-name "symbol-menu"))

(defun symbol-menu-quit ()
  (interactive)
  (let ((owin (get-buffer-window symbol-menu-target-buffer)))
    (delete-window)
    (if owin (select-window owin))))
    
(defun symbol-menu-insert-symbol-to-target ()
  (interactive)
  (let ((owin (get-buffer-window symbol-menu-target-buffer))
	(cwin (get-buffer-window (current-buffer)))
	(sym (char-after)))
    (select-window owin)
    (insert-char sym 1)
    (select-window cwin)))
